/*
 *  Blinkless Demo -- WiFiBoy32 Demo Code for Arduino/ESP32
 *   
 *  Nov 26, 2017 Created. (derek@wifiboy.org)
 *
 */
#include <wifiboy32.h>
#include "wb32_sprite.h"

int ball_x, ball_y, dx, dy, bar_x;

void setup() {

  wb32_init(); // init WiFiBoy32 engine

  wb32_initBuf8(); // prepare 76800-byte off-screen buffer
  
  for(int i=0; i<256; i++) // setup palette (8bit = 256 colors)
    wb32_setPal8(i, wb32_color565(sprite_pal[i][0],sprite_pal[i][1],sprite_pal[i][2]));
  
  ball_x = ball_y = 10;
  dx = dy = 5;
  
  bar_x = 100;
  pinMode(17, INPUT); 
  pinMode(32, INPUT);

}

void loop() 
{
  wb32_clearBuf8(); // clear off-screen buffer

  if (digitalRead(17)==0) bar_x -= 8;
  if (bar_x < 0) bar_x = 0;
  if (digitalRead(32)==0) bar_x += 8;
  if (bar_x > 200) bar_x = 200;
  
  wb32_blitBuf8(68, 218, 240, bar_x, 310, 40, 8, (uint8_t *)sprites);
  
  ball_x += dx;
  if ((ball_x > 230) || (ball_x < 0)) { dx=-dx; ball_x += dx; }
  ball_y += dy;
  if (ball_y < 0) { dy=-dy; ball_y += dy; }
  
  if (ball_y > 300) {
    if ((ball_x+10 >= bar_x) && (ball_x <= bar_x+40)) dy=-dy;
    else {
      ball_x = ball_y = 10; // restart
      dx = dy = 5;
    }
  }
  
  wb32_blitBuf8(196, 196, 240, ball_x, ball_y, 10, 10, (uint8_t *)sprites);
  
  wb32_blit8(); // blit to LCD
  //delay(50);
}
