/*
 *  DrawTest -- WiFiBoy32 Demo Code for Arduino/ESP32
 *
 *  Oct 13, 2017 Created. (derek@wifiboy.org)
 *
 */
#include "wifiboy32.h"
#include "wb32-demo2.h"

void setup() 
{
  wb32_init();
  wb32_fillScreen(0);

  int x1, y1, x2, y2;
  x1 = y1 = 0;
  y2 = 319;
  for(x2=0; x2<240; x2+=6) wb32_drawLine(x1, y1, x2, y2, 0xf8, 1);
  x2 = 239;
  for(y2=0; y2<320; y2+=6) wb32_drawLine(x1, y1, x2, y2, 0xf8, 1);
  delay(2000);
  wb32_fillScreen(0); 
}

void loop() {
  wb32_drawImage(56,118,128,160, (uint16_t *)img);
  wb32_setTextColor(wbCYAN, wbCYAN);
  wb32_drawString("WiFiBoy", 24, 30, 1, 6);
  wb32_setTextColor(wbRED, wbRED);
  wb32_drawString("32", 185, 44, 1, 4);
  wb32_drawFastHLine(10, 80, 220, wbYELLOW);
  wb32_drawFastHLine(10, 81, 220, wbYELLOW);
  wb32_setTextColor(wbWHITE, wbWHITE);
  wb32_drawString("LCD Draw Test", 50, 88, 2, 2);
  wb32_setTextColor(wbGREEN, wbGREEN);
  wb32_drawString("(C)2017 WiFiBoy.Org, All Rights Reserved", 20, 300, 2, 1);

  delay(2000);
  wb32_fillScreen(0);

  for(int i=0; i<800; i++) 
    wb32_drawRect(rand()%120, rand()%240, rand()%128, rand()%128, rand()%65536);
  wb32_fillScreen(0);  
  
  for(int i=0; i<2000; i++) 
    wb32_fillRect(rand()%220, rand()%300, 16, 16, rand()%65536);
  wb32_fillScreen(0);
  
  for(int i=0; i<100; i++) {
    wb32_drawImage(rand()%110,rand()%190,128,128, (uint16_t *)img);
  }
  wb32_fillScreen(0);

  for(int i=0; i<30; i++) {
    for(int y=0; y<320; y+=5) wb32_drawFastHLine(0, y, 240, rand()%65536);
    for(int x=0; x<240; x+=5) wb32_drawFastVLine(x, 0, 320, rand()%65536);
  }
  wb32_fillScreen(0);
  
  for(int i=0; i<120; i+=8) wb32_drawCircle(120, 160, i, rand()%65536, 1);

  for(int i=0; i<120; i+=8) wb32_drawCircle(120, 160, i, rand()%65536, 2);
  wb32_fillScreen(0);
  
  for(int i=0; i<120; i+=8) wb32_drawCorner(120, 160, i, 5, rand()%65536, 1);
  for(int i=0; i<120; i+=8) wb32_drawCorner(120, 160, i, 5, rand()%65536, 2);
  wb32_fillScreen(0);

  for(int i=0; i<60; i++)
      for(int i=0; i<120; i+=5) wb32_drawRect(120-i, 160-i, i*2, i*2, rand()%65536); 
  wb32_fillScreen(0);
}
