#include <WiFi.h>
#include "wifiboy32.h"

WiFiServer server(1234);  // port 1234 for game server
WiFiClient client;   

char str[3][9]={
  "Paper", "Stone", "Scissors"
};

int game_mode=0;

void setup() 
{
  wb32_init();
  wb32_setTextColor(wbCYAN, wbCYAN);
  
  pinMode(17, INPUT); 
  pinMode(32, INPUT);
  pinMode(34, INPUT);

  while(game_mode==0) {
    if (digitalRead(32)==0) { 
      wb32_drawString("PLAYER-1", 75, 120, 2, 2);
      WiFi.softAP("SPS1", "12345678");
      server.begin();
      game_mode=1; 
      while(1) {
        client = server.available();
        if (client) break;
      }
    } else if (digitalRead(17)==0) { 
      wb32_drawString("PLAYER-2", 75, 120, 2, 2);
      WiFi.begin("SPS1", "12345678");
      while(WiFi.status()!=WL_CONNECTED) delay(500);
      client.connect("192.168.4.1", 1234);
      while(!client.connected());
      game_mode=2; 
    }
  }
  
  wb32_fillScreen(0);
}

void loop() 
{
  int x, y;
  
  x = 0;
  while(x==0) {
    if (digitalRead(17)==0) x = 1;
    if (digitalRead(32)==0) x = 2;
    if (digitalRead(34)==0) x = 3;
  }
  wb32_fillScreen(0);
  wb32_drawString(str[x-1], 50, 200, 2, 2);
  
  while(client.write(x)==0);
  
  while(client.available()==0);
  while(client.available()) y = client.read();
  
  wb32_drawString(str[y-1], 50, 120, 2, 2);

  if (x==y) {
    wb32_drawString("Draw!", 50, 160, 2, 2);
  } else if (((x==1) && (y==2)) || ((x==2) && (y==3)) || ((x==3) && (y==1))) {
    wb32_drawString("You Win!", 50, 160, 2, 2);
  } else wb32_drawString("You Lose!", 50, 160, 2, 2);

}
