/*
 *  Pong Test 2 -- WiFiBoy32 Demo Code for Arduino/ESP32
 *
 *  Nov 25, 2017 Created. (derek@wifiboy.org)
 *
 */
#include "wifiboy32.h"

int ball_x, ball_y, dx, dy, bar_x;

void setup_sound()
{
  ledcSetup(1, 400, 8); // ledc/pwm ch#1, freq=400, duty resolution=8bit (0-255)
  ledcAttachPin(25, 1); // IO#25=buzzer, attached to pwm#1
}

void make_sound(int volume)
{
  ledcWrite(1, volume);
}

void sound_freq(int freq)
{
  ledcSetup(1, freq, 8);
}

void setup() 
{
  wb32_init();

  ball_x = ball_y = 10;
  dx = dy = 3;
  
  bar_x = 100;
  pinMode(17, INPUT); 
  pinMode(32, INPUT);

  setup_sound();
}

void loop() 
{
  if (digitalRead(17)==0) bar_x -= 4;
  if (bar_x < 0) bar_x = 0;
  if (digitalRead(32)==0) bar_x += 4;
  if (bar_x > 200) bar_x = 200;
  
  wb32_fillRect(bar_x, 310, 40, 8, wbRED);
  
  ball_x += dx;
  if ((ball_x > 230) || (ball_x < 0)) { 
    dx=-dx; ball_x += dx; 
    make_sound(50);;
  }
  ball_y += dy;
  if (ball_y < 0) { 
    dy=-dy; ball_y += dy; 
    make_sound(50); 
  }
  
  if (ball_y > 300) {
    if ((ball_x+10 >= bar_x) && (ball_x <= bar_x+40)) {
      dy=-dy;
      make_sound(50); 
    } else {
      ball_x = ball_y = 10; // restart
      dx = dy = 3;
      sound_freq(100);
      make_sound(50);
      delay(500);
      sound_freq(400);
    }
  }
  
  wb32_fillRect(ball_x, ball_y, 10, 10, wbGREEN);

  delay(20);
  
  wb32_fillRect(ball_x, ball_y, 10, 10, wbBLACK);
  wb32_fillRect(bar_x, 310, 40, 8, wbBLACK);
  make_sound(0);
}
